/*
 Copyright 2015 Nicolas Melot

 This file is part of Drake-merge.

 Drake-merge is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Drake-merge is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Drake-merge. If not, see <http://www.gnu.org/licenses/>.

*/


/*
 * generate.c
 * Copyright 2011 Kenan Avdic <kavdic@gmail.com>
 * 2011-06-30
 *
 * Simple code to generate a file containing a number of integers. Takes
 * filename and a number of integers as argument. The number of integers
 * is multiplied by power-of-two million (Mebi-integers).
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <assert.h>

#include <pelib/integer.h>

#define MEBI (1024*1024)

int
main(int argc, char **argv)
{
	FILE *fp;
	int i, retval, val;
	size_t N;
	array_t(int) *array;

	if (argc < 3 || argc > 4)
	{
		printf("Usage: %s {filename} {count} [constant value]\n", *argv);
		return 0;
	}

	char * filename = *++argv;

	N = atoi(*++argv);
	array = pelib_alloc_collection(array_t(int))(N);
	if(array == NULL)
	{
		printf("Cannot allocate the %zu bytes of memory required.\n", N * sizeof(int));
		return EXIT_FAILURE;
	}

	argv++;
	srand(time(NULL));

	if (argc == 4)
	{
		for (i = 0; i < N; i++)
		{
			val = atoi(*argv);
			pelib_array_append(int)(array, val);
		}
	}
	else
	{
		for (i = 0; i < N; i++)
		{
			//val = rand() % (N * 1000);
			//val = val - (val % 1000);
			//val += i / (N / 512);
			//val = rand();
			val = N - i;
			//val = i;

			pelib_array_append(int)(array, val);
		}
	}
	pelib_array_storefilenamebinary(int)(array, filename);

	return 0;
}

